<?php
namespace App\Http\Controllers\Api;

use App\Service\EmployeeService;
use App\Service\TokenService;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Redis;

//登录
class LoginController extends BaseController
{
    public function login(Request $request){
        $data = $request->only("account","password");

        //登录
        $result = (new EmployeeService())->loginRule($data);
        list($bool, $return) = $result;
        if(! $bool) return $this->json_return(201,'',$return);

        //生成token
        $jwtToken = TokenService::getToken($return['id']);

        return $this->json_return(200,'', ['token' => $jwtToken, 'account' => $return['account'], 'role' => $return['role'], 'role_menu' => $return['role_menu']]);
    }
}
