<?php

namespace App\Service;

use App\Model\SystemRecord;
use App\Model\Warning;

class SystemRecordService extends Service
{
    public function orderList($data){
        $model = SystemRecord::select('account','crt_time','ip','content')
            ->orderBy('id','desc');
        if(! empty($data['crt_time'][0]) && ! empty($data['crt_time'][1])){
            $return = $this->changeDateToTimeStampAboutRange($data['crt_time']);
            $model->where('crt_time','>=',$return[0]);
            $model->where('crt_time','<',$return[1]);
        }
        if(! empty($data['content'])) $model->where('content', 'LIKE', '%'.$data['content'].'%');

        $list = $this->limit($model,'',$data);
        $list = $this->fillData($list);
        return [true,$list];
    }

    public function fillData($data){
        if(empty($data['data'])) return $data;

        foreach ($data['data'] as $key => $value){
            $data['data'][$key]['crt_time'] = $value['crt_time'] ? date('Y-m-d H:i:s',$value['crt_time']) : '';
        }

        return $data;
    }

    public function warningList($data){
        $list = Warning::where('state',0)
            ->where('value',1)
            ->select('device_name','device_no','data_point_name','time','id')
            ->orderBy('id','desc')
            ->get()->toArray();
        foreach ($list as $key => $value){
            $list[$key]['time'] = date("Y-m-d H:i:s",$value['time']);
        }

        return [true,$list];
    }

    public function warningEdit($data){
        if(empty($data['id'])) return [false,'ID不能为空'];
        Warning::where('id',$data['id'])->update(['state' => 1]);
        return [true,''];
    }
}
