<?php

use Illuminate\Http\Request;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

Route::middleware('auth:api')->get('/user', function (Request $request) {
    return $request->user();
});

Route::any('login', 'Api\LoginController@login');
Route::any('getHeaderWord', 'Api\HeaderWordController@getHeaderWord');
Route::any('getHeaderSetting', 'Api\HeaderWordController@getHeaderSettings');

//测试接口
Route::any('test', 'Api\TestController@aa');

Route::group(['middleware'=> ['checkLogin']],function ($route){
    $route->any('HeaderSettingsAdd', 'Api\HeaderWordController@add');
    $route->any('HeaderSettingsDetail', 'Api\HeaderWordController@detail');

    //人员
    $route->any('employeeAdd', 'Api\EmployeeController@employeeAdd');
    $route->any('employeeEdit', 'Api\EmployeeController@employeeEdit');
    $route->any('employeeDel', 'Api\EmployeeController@employeeDel');
    $route->any('employeeList', 'Api\EmployeeController@employeeList');

    //角色
    $route->any('roleAdd', 'Api\EmployeeController@roleAdd');
    $route->any('roleEdit', 'Api\EmployeeController@roleEdit');
    $route->any('roleDel', 'Api\EmployeeController@roleDel');
    $route->any('roleList', 'Api\EmployeeController@roleList');
    $route->any('roleMenu', 'Api\EmployeeController@roleMenu');

    //区域档案
    $route->any('areaList', 'Api\AreaController@areaList');
    $route->any('areaAdd', 'Api\AreaController@add');
    $route->any('areaEdit', 'Api\AreaController@edit');
    $route->any('areaDel', 'Api\AreaController@del');

    //网关
    $route->any('gatewayAdd', 'Api\GatewayController@equipmentAdd');
    $route->any('gatewayEdit', 'Api\GatewayController@equipmentEdit');
    $route->any('gatewayDel', 'Api\GatewayController@equipmentDel');
    $route->any('gatewayList', 'Api\GatewayController@equipmentList');

    //设备类型
    $route->any('deviceTypeAdd', 'Api\DeviceController@deviceAdd');
    $route->any('deviceTypeEdit', 'Api\DeviceController@deviceEdit');
    $route->any('deviceTypeDel', 'Api\DeviceController@deviceDel');
    $route->any('deviceTypeList', 'Api\DeviceController@deviceTypeList');

    //设备列表
    $route->any('deviceAdd', 'Api\DeviceController@deviceAdd');
    $route->any('deviceEdit', 'Api\DeviceController@deviceEdit');
    $route->any('deviceDel', 'Api\DeviceController@deviceDel');
    $route->any('deviceList', 'Api\DeviceController@deviceList');

    //仓
    $route->any('screenAdd', 'Api\ScreenController@add');
    $route->any('screenEdit', 'Api\ScreenController@edit');
    $route->any('screenDel', 'Api\ScreenController@del');
    $route->any('screenList', 'Api\ScreenController@orderList');//仓列表
    $route->any('screenDeviceList', 'Api\ScreenController@screenDeviceList');//仓绑定的设备列表
    $route->any('screenDevice', 'Api\ScreenController@screenDevice');//仓绑定设备
    $route->any('screenRemoveDevice', 'Api\ScreenController@screenRemoveDevice');//仓移除设备
    $route->any('screenDeviceDataRealTimeList', 'Api\ScreenController@screenDeviceDataRealTimeList');//仓设备实时数据列表
    $route->any('screenHistoryList', 'Api\ScreenController@screenHistoryList');//历史数据

    //操作日志
    $route->any('systemRecordList', 'Api\SystemRecordController@orderList');
    //预警列表
    $route->any('warningList', 'Api\SystemRecordController@warningList');
    //改变预警状态
    $route->any('warningEdit', 'Api\SystemRecordController@warningEdit');

    //暂时没用----------------------------
    //菜单
    $route->any('menuAdd', 'Api\SysMenuController@add');
    $route->any('menuEdit', 'Api\SysMenuController@edit');
    $route->any('menuDel', 'Api\SysMenuController@del');
    $route->any('menuList', 'Api\SysMenuController@menuList');
    $route->any('menuMove', 'Api\SysMenuController@menuMove');
    //部门
    $route->any('departAdd', 'Api\EmployeeController@departAdd');
    $route->any('departEdit', 'Api\EmployeeController@departEdit');
    $route->any('departDel', 'Api\EmployeeController@departDel');
    $route->any('departList', 'Api\EmployeeController@departList');
    //班组
    $route->any('teamAdd', 'Api\EmployeeController@teamAdd');
    $route->any('teamEdit', 'Api\EmployeeController@teamEdit');
    $route->any('teamDetail', 'Api\EmployeeController@teamDetail');
    $route->any('teamDel', 'Api\EmployeeController@teamDel');
    $route->any('teamList', 'Api\EmployeeController@teamList');
    //绑定
    $route->any('employeeDepart', 'Api\EmployeeController@employeeDepart');
    $route->any('employeeTeam', 'Api\EmployeeController@employeeTeam');
    //暂时没用----------------------------

    //报表
    $route->any('productionReport', 'Api\ReportFormsController@productionReport');
    $route->any('teamReport', 'Api\ReportFormsController@teamReport');
    $route->any('teamReportDetail','Api\ReportFormsController@teamReportDetail');
    $route->any('badGoodsReport', 'Api\ReportFormsController@badGoodsReport');
    $route->any('badGoodsReportDetail','Api\ReportFormsController@badGoodsReportDetail');
    $route->any('badGoodsReasonReport', 'Api\ReportFormsController@badGoodsReasonReport');
    $route->any('badGoodsReasonReportDetail','Api\ReportFormsController@badGoodsReasonReportDetail');

    //请求表头信息
    $route->any('getHeaderWord', 'Api\HeaderWordController@getHeaderWord');
});
